%				Modulation of associative memory function by ACh
% 								Base model and script
%
% Authors: Michael Hasselmo, Jean-Marc Fellous
% in 'Neuromodulation: Increasing Computational Power', Fellous JM, Canavier C and Hasselmo M, 
%			From Brain to Cognition via Computational Neuroscience (M.A. Arbib, editor), 2014.
%
% This script will setup the model and enter an interactive mode in which
% 	the user can change the training patterns (during learning) and/or the cue pattern
%	during recall



clear all; close all;


%Define presynaptic activity vectors apre
apre1=[0; 1; 1; 0; 0; 1; 0; 1; 0; 0];
apost1=[1; 0; 1; 0; 1; 1; 1; 0];

apre2=[0; 0; 1; 1; 0; 0; 0; 1; 0; 1];
apost2=[0; 1; 0; 1; 0; 0; 0; 1];

%apre3=[0;0;0;1;0;0;1;0;1;0];		% uncomment for exercise 4-5 
%apost3=[0;0;1;0;1;0;1;0];			% uncomment for exercise 4-5 

%Create initial synaptic connectivity matrix.
W=zeros(length(apost1),length(apre1));

%Concatenate all pre and post pairs of patterns
Apre=[apre1, apre2];				% (put as many as you want)
Apost=[apost1, apost2];			% (put as many as you want, but same amount as above)

%Apre=[apre1, apre2, apre3];				% uncomment for exercise 4-5 
%Apost=[apost1, apost2, apost3];			% uncomment for exercise 4-5 


%ENCODING

%Set presence of cholinergic modulation.
ACh=1;

% Learn the pre-post associations
NewW=AChLearn(Apre,Apost,W,ACh);

%RETRIEVAL 

%Perform retrieval by giving input acue and
%seeing how activity spreads across modified synapses using W*acue

%First create degraded inputs cue, acue, for retrieval.
acue1=[0;0;0;1;0;0;0;0;0;1]; %Note that the cue does NOT overlap with pattern 1.
acue2=[0;1;1;0;0;0;0;0;0;0]; %
%acue3=[0;0;0;0;0;0;0;0;1;0];			% uncomment for exercise 4-5 

ACue=[acue1, acue2];			% (put as many as you want)
%ACue=[acue1, acue2, acue3];			% uncomment for exercise 4-5 

Out=AChRecall(ACue,NewW,ACh);	% test the network


%PLOT FIGURES and start the Interactive session

AChPlot(Apre,Apost,NewW,ACue,Out,ACh)

